	/*PROGRAM TO DEMONSTATE CLIPING OF A LINE BY CYRUS-BECK ALGO.*/

#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<graphics.h>
#include<dos.h>
#include<time.h>
#include<iostream.h>
#include<stdlib.h>
#include"c:\tc\graphics\mid_line.h"

#define FALSE 0
#define TRUE  1

int winx0,winx1,winy0,winy1;
int poly[8];

int clipt(double denom,double num,double *tE,double *tL);
int cliping(double x0,double y0);

void clip(double *x0,double *y0,double *x1,double *y1,int *visible)
{
 double dx=*x1-*x0;
 int i=1;
 double dy=*y1-*y0;
 *visible=FALSE;
 while(i<=2)
  {
    if(dx==0 && dy==0 && cliping(*x0,*y0)) *visible=TRUE;
    else
     {
       double tE=0.0;
       double tL=1.0;
	if (clipt(dx,winx0-*x0,&tE,&tL))
	 if(clipt(-dx,*x0-winx1,&tE,&tL))
	  if (clipt(dy,winy0-*y0,&tE,&tL))
	   if(clipt(-dy,*y0-winy1,&tE,&tL))
	    {
	       *visible=TRUE;
	       if (tL<1.0)
		{
		  *x1=*x0+tL*dx;
		  *y1=*y0+tL*dy;
		}
	       if (tE>0.0)
		{
		  *x0=*x0+tE*dx;
		  *y0=*y0+tE*dy;
		}
	    }//end outer if
     }//end else
   i++;
 }
}

int clipt(double denom,double num,double *tE,double *tL)
{
 double t;
 if (denom>0)   	      		//PE intersection
  {
    t=num/denom;               		//value of t at intersection
    if((int)t>*tL) return(FALSE);       //tE and tL crossover so reject the line
    else if ((int)t>*tE) *tE=t;         //a new tE is found
  }
  else if(denom<0)             		//PL intersection
   {
     t=num/denom;               	//value of t at intersection
     if(t<*tE) return(FALSE);    	//tE and tL crossover so reject the line
     else *tL=t;    	        	//a new tE is found
   }
  else if(num>0) return(FALSE);	        //line on outside the edge
  return(TRUE);
}//end clipt

int cliping(double x0,double y0)
{
 if (x0>winx0 && x0<winx1 && y0>winy0 && y0<winy1) return (TRUE);
 else return(FALSE);
}

void main(void)
{
 struct tm *tblock;
 time_t t;
 t=time(NULL);
 tblock=localtime(&t);
 int color,visible;
 int xmax,ymax;
 int gd=DETECT,gm,errorcode;
 double x0,x1,y0,y1;
 clrscr();
 gotoxy(0,0);
 cout<<"-----------------------------------------------------------------";
 printf("--PROGRAM TO DEMONSTATE CLIPPING OF A LINE BY CYRUS-BECK ALGO.--\n");
 cout<<"-----------------------------------------------------------------";
 printf("\n\nTODAY's DATE IS : %.24s",asctime(tblock));
 cout<<"\nPLEASE ENTER COORDINATES OF THE LINE TO BE CLIPPED\n";
 cout<<"\n\nPLEASE ENTER X-COORDINATE OF 1st POINT :";
 cin>>x0;
 cout<<"PLEASE ENTER Y-COORDINATE OF 1st POINT :";
 cin>>y0;
 cout<<"PLEASE ENTER X-COORDINATE OF 2nd POINT :";
 cin>>x1;
 cout<<"PLEASE ENTER Y-COORDINATE OF 2nd POINT :";
 cin>>y1;
 cout<<"\n\t------ MAIN MENU --------------";
 cout<<"\n\t-1. CHOOSE 1 FOR BLUE----------";
 cout<<"\n\t-2. CHOOSE 2 FOR GREEN---------";
 cout<<"\n\t-3. CHOOSE 3 FOR CYAN----------";
 cout<<"\n\t-4. CHOOSE 4 FOR RED-----------";
 cout<<"\n\t-5. CHOOSE 5 FOR MAGENTA-------";
 cout<<"\n\t-6. CHOOSE 6 FOR BROWN---------";
 cout<<"\n\t-7. CHOOSE 7 FOR LIGHT GRAY----";
 cout<<"\n\t-8. CHOOSE 8 FOR DARK GRAY-----";
 cout<<"\n\t-9. CHOOSE 9 FOR LIGHT BLUE----";
 cout<<"\n\t-10. CHOOSE 10 FOR LIGHT GREEN-";
 cout<<"\n\t-11. CHOOSE 11 FOR LIGHT CYAN--";
 cout<<"\n\t-------------------------------";
 cout<<"\n\tPLEASE CHOOSE (1-11) FOR COLOUR :";
 cin>>color;
 clrscr();
 cout<<"\nPLEASE ENTER THE CLIPPING WINDOWS's LEFTMOST POINT's COORDINATES :";
 cin>>winx0>>winy0;
 cout<<"\nPLEASE ENTER THE CLIPPING WINDOWS's RIGHTMOST POINT's COORDINATES :";
 cin>>winx1>>winy1;
 poly[0]=winx0; 	 //POINT LOCATION FOR FILL COLOR
 poly[1]=winy0;
 poly[2]=winx1;
 poly[3]=winy0;
 poly[4]=winx1;
 poly[5]=winy1;
 poly[6]=winx0;
 poly[7]=winy1;
 initgraph(&gd,&gm,"c:\\tc\\bgi");
 errorcode=graphresult();
 if (errorcode != grOk)              /* an error occurred */
  {
     printf("Graphics error: %s\n", grapherrormsg(errorcode));
     printf("Press any key to halt:");
     getch();
     exit(1);                       /* terminate with an error code */
  }
 setbkcolor(BLACK);
 settextstyle(0,0,0);
 xmax=getmaxx();
 ymax=getmaxy();
 setcolor(WHITE);
 rectangle(0,0,xmax,ymax);
 outtextxy(10,10,"FULL SCREEN");
 rectangle(winx0,winy1,winx1,winy0);
 setfillstyle(2,10);
 fillpoly(4,&poly[0]);
 outtextxy((winx0-10),(winy0-10),"CLIPPING WINDOW");
 nik_line_mps(x0,y0,x1,y1,color);
 getch();
 cleardevice();
 clip(&x0,&y0,&x1,&y1,&visible);
 rectangle(winx0,winy0,winx1,winy1);
 setfillstyle(2,10);
 fillpoly(4,poly);
 outtextxy((winx0-10),(winy0-10),"CLIPPING WINDOW");
 outtextxy((winx0-20),(winy0-20),"THIS IS THE  CLIPPED LINE");
 nik_line_mps(x0,y0,x1,y1,color);
 getch();
 closegraph();
 restorecrtmode();
 printf("\nHAVE A GOOD DAY!\n");
 getch();
}

